(* ****************************************************************************
 *                    Fumio Kawamata's Quick Recall
 *                  Copyright (C) 1998 Fumio Kawamata
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; version 2 of the License.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
 *  ABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
 *  Public License in the directory "manual" for more details.
 * ****************************************************************************
 *)

(* ****************************************************************************
 *
 * ****************************************************************************
 *)

unit main;

interface

uses
  ShellAPI,Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, Buttons, Grids, DBGrids, Db, DBTables,jpeg,
  Menus, DBCtrls,
  ImgTrans,Global;


type
  TformMain = class(TForm)
    datasourceAlbum             : TDataSource;
    dbgridAlbum                 : TDBGrid;
    dialogOpen                  : TOpenDialog;
    dialogSave                  : TSaveDialog;
    imageTmp                    : TImage;
    imageViewArea               : TImage;
    menuDisplay                 : TMenuItem;
    menuDisplayExpert           : TMenuItem;
    menuDisplayFilter           : TMenuItem;
    menuDisplayKeywordList      : TMenuItem;
    menuDisplayRefresh          : TMenuItem;
    menuDisplaySlide            : TMenuItem;
    menuDisplaySlideshow        : TMenuItem;
    menuFile                    : TMenuItem;
    menuFileDelete              : TMenuItem;
    menuFileExit                : TMenuItem;
    menuFileExport              : TMenuItem;
    menuFileExportCurrent       : TMenuItem;
    menuFileInport              : TMenuItem;
    menuFileInportFile          : TMenuItem;
    menuFileNew                 : TMenuItem;
    menuFileOpen                : TMenuItem;
    menuHelp                    : TMenuItem;
    menuHelpInEng               : TMenuItem;
    menuHelpInJap               : TMenuItem;
    menuHelpSeparator           : TMenuItem;
    menuHelpVersion             : TMenuItem;
    menuMain                    : TMainMenu;
    menuOption                  : TMenuItem;
    menuOptionAutoScale         : TMenuItem;
    menuOptionDeleteRegistory   : TMenuItem;
    menuOptionLayout            : TMenuItem;
    menuOptionSeparator         : TMenuItem;
    menuOptionTableHeight       : TMenuItem;
    menuOptionTableHeightHigher : TMenuItem;
    menuOptionTableHeightLower  : TMenuItem;
    menuOptionWaitTime          : TMenuItem;
    menuOptionWaitTimeValue     : TMenuItem;
    panelBottom                 : TPanel;
    panelClient                 : TPanel;
    panelCommand                : TPanel;
    panelStatusBar              : TStatusBar;
    queryAlbum                  : TQuery;
    scrollboxViewArea           : TScrollBox;
    tableNew                    : TTable;
    timerWaitTime               : TTimer;
    menuDisplayKeywordAssist: TMenuItem;
    menuDisplayKeywordEdit: TMenuItem;
    panelCommandUpper: TPanel;
    panelCommandLower: TPanel;
    bitbtnExit: TBitBtn;
    imageLogo: TImage;
    radiogroupScale: TRadioGroup;
    groupboxTableHeight: TGroupBox;
    bitbtnHeightUp: TBitBtn;
    bitbtnHeightDown: TBitBtn;
    labelCount: TLabel;
    editCounter: TEdit;
    bitbtnFilter: TBitBtn;
    dbnavigatorPrevNext: TDBNavigator;
    dbnavigatorPostCancel: TDBNavigator;
    bitbtnKeywordAssist: TBitBtn;
    tableKeyword: TTable;
    dbnavigatorTopLast: TDBNavigator;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure menuDisplayExpertClick(Sender: TObject);
    procedure menuDisplayFilterClick(Sender: TObject);
    procedure menuDisplayKeywordListClick(Sender: TObject);
    procedure menuDisplayRefreshClick(Sender: TObject);
    procedure menuDisplaySlideClick(Sender: TObject);
    procedure menuDisplaySlideshowClick(Sender: TObject);
    procedure menuFileDeleteClick(Sender: TObject);
    procedure menuFileExitClick(Sender: TObject);
    procedure menuFileExportCurrentClick(Sender: TObject);
    procedure menuFileInportFileClick(Sender: TObject);
    procedure menuFileNewClick(Sender: TObject);
    procedure menuFileOpenClick(Sender: TObject);
    procedure menuHelpInEngClick(Sender: TObject);
    procedure menuHelpInJapClick(Sender: TObject);
    procedure menuHelpVersionClick(Sender: TObject);
    procedure menuOptionAutoScaleClick(Sender: TObject);
    procedure menuOptionDeleteRegistoryClick(Sender: TObject);
    procedure menuOptionLayoutClick(Sender: TObject);
    procedure menuOptionTableHeightHigherClick(Sender: TObject);
    procedure menuOptionTableHeightLowerClick(Sender: TObject);
    procedure menuOptionWaitTimeClick(Sender: TObject);
    procedure queryAlbumAfterDelete(DataSet: TDataSet);
    procedure queryAlbumAfterEdit(DataSet: TDataSet);
    procedure queryAlbumAfterInsert(DataSet: TDataSet);
    procedure queryAlbumAfterPost(DataSet: TDataSet);
    procedure queryAlbumAfterScroll(DataSet: TDataSet);
    procedure radiogroupScaleClick(Sender: TObject);
    procedure timerWaitTimeTimer(Sender: TObject);
    procedure menuDisplayKeywordAssistClick(Sender: TObject);
    procedure menuDisplayKeywordEditClick(Sender: TObject);
    procedure bitbtnKeywordAssistClick(Sender: TObject);
    procedure queryAlbumBeforePost(DataSet: TDataSet);
  private
    procedure CreateTables(DatabaseDir:String);
    procedure DisplayWaitTime(WaitTime:integer);
    procedure IncCounter;
    procedure RestoreOptionStatus;
    procedure StoreOptionStatus;
    procedure CheckKeywordEntry;
  public
    procedure DisplayRecordCount;
  end;

var
    Clicked     : Boolean;  (* True when clicked *)
    formMain    : TformMain;
    OnTime      : Boolean;  (* True when timer ontime *)

procedure DisplayResult(Code: word; FileName:String);

implementation

uses FileCtrl,Registry,Selector, RegUtl, Expert, Easy, Slide, VerInfo,
  KeywordList, keywordassist, KeywordEdit;

var
  Edited   : Boolean;
  WaitTime : integer;
  LastSerial  : Longint;

{$R *.DFM}


function IsShown(FormName:String):Boolean;
var
  I : Integer;
begin
  Result:=False;
  I:=0;
  while (I<Screen.FormCount)and(Result=False) do begin
    if Screen.Forms[I].Name=FormName then Result:=True;
    inc(I);
  end;
  IsShown:=Result;
end;

procedure TformMain.CheckKeywordEntry;
var
  KeyWord  : String;
  KeyWords : String;
begin
  KeyWords:=queryAlbum.FieldByName('KEYWORD').AsString;
  if KeyWords='' then Exit;
  while KeyWords<>'' do begin
    KeyWord:=ShiftWord(KeyWords,',');
    if tableKeyword.FindKey([KeyWord]) = False then begin
      if MessageDlg('"'+KeyWord+'" is a new keyword. '+
        'Would you append it into the database?', mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
        tableKeyword.Append;
        tableKeyword.FieldByName('KEYWORD').AsString:=KeyWord;
        tableKeyword.FieldByName('COUNT').AsInteger:=1;
        tableKeyword.Post;
      end;
    end;
  end;
end;

procedure TformMain.IncCounter;
(* ****************************************************************************
 * Increment counter field in the database table.
 * This counter value is for "My favorite photo".
 * ****************************************************************************
 *)
var
  Count : Longint;
begin
  Count:=queryAlbum.FieldByName('COUNT').AsInteger;
  inc(Count);
  queryAlbum.Edit;
  queryAlbum.FieldByName('COUNT').AsInteger:=Count;
  queryAlbum.Post;
end;


procedure TformMain.DisplayWaitTime(WaitTime: integer);
(* ****************************************************************************
 * Displays the "Wait time" of the slideshow.
 * The program just waits while "WaitTime" seconds.
 * ****************************************************************************
 *)
begin
  menuOptionWaitTimeValue.Caption:='Wait Time: '+IntToStr(WaitTime)+' sec.';
  timerWaitTime.Interval:=WaitTime*1000;
end;


procedure TformMain.StoreOptionStatus;
(* ****************************************************************************
 * Stores option statuses such as form position, wait time, panel layout, etc.
 * ****************************************************************************
 *)
var
    AlignStr    : String;
    Reg         : TRegIniFile;
    SubKeyName  : String;
begin
  case panelCommand.Align of
    alLeft : AlignStr:='Left';
    alRight : AlignStr:='Right';
  end;
  SubKeyName:=formMain.Name;
  Reg:=TRegIniFile.Create(BaseKeyName);
  Reg.WriteString(SubKeyName,'Panel_Layout',AlignStr);
  Reg.WriteInteger(SubKeyName,'Table_Height',dbgridAlbum.Height);
  Reg.WriteString(SubKeyName,'Database_Name',queryAlbum.DatabaseName);
  Reg.WriteInteger(SubKeyName,'Wait_Time',WaitTime);
  Reg.Free;
end;


procedure TformMain.RestoreOptionStatus;
(* ****************************************************************************
 * Restores option statuses which are stored by "StoreOptionStatus" procedure.
 * ****************************************************************************
 *)
var
    AlignStr            : String;
    LastDatabaseName    : String;
    Reg                 : TRegIniFile;
    SubKeyName          : String;
begin
  SubKeyName:=formMain.Name;
  Reg:=TRegIniFile.Create(BaseKeyName);
  AlignStr:=Reg.ReadString(SubKeyName,'Panel_Layout','Right');
  if AlignStr='Right'
    then panelCommand.Align:=alRight
    else panelCommand.Align:=alLeft;
  dbgridAlbum.Height:=Reg.ReadInteger(SubKeyName,'Table_Height',dbgridAlbum.Height);
  LastDatabaseName:=Reg.ReadString(SubKeyName,'Database_Name','');
  WaitTime:=Reg.ReadInteger(SubKeyName,'Wait_Time',3);
  DisplayWaitTime(WaitTime);
  Reg.Free;


  tableKeyword.Active:=False;
  tableKeyword.DatabaseName:=LastDatabaseName;
  if tableKeyword.DatabaseName<>'' then begin
    try
      tableKeyword.Active:=True;
   except
      tableKeyword.Active:=False;
      MessageDlg('Could not open Keyword Table in "'+LastDatabaseName+'".',mtWarning,[mbOK],0);
    end;
  end;

  queryAlbum.Active:=False;
  queryAlbum.DatabaseName:=LastDatabaseName;
  if queryAlbum.DatabaseName<>'' then begin
    try
      queryAlbum.Active:=True;
      DisplayRecordCount;
   except
      queryAlbum.Active:=False;
      MessageDlg('Could not open Photo Table in "'+LastDatabaseName+'".',mtWarning,[mbOK],0);
    end;
  end;

end;


procedure DisplayResult(Code: word; FileName:string);
(* ****************************************************************************
 * Displays the result of the shellexecute command.
 * The program uses the shell exexute command due to open the HTML file for
 * user help.
 * ****************************************************************************
 *)
var
     CodeStr        : String;
begin
  if Code<32 then begin
    str(Code, CodeStr);
    MessageDlg('Could not shellexecute "'+FileName+'".'+chr($0D)+
      'Return Code was '+CodeStr+' .', mtWarning, [mbOK],0);
  end;
end;



procedure TformMain.menuHelpInEngClick(Sender: TObject);
(* ****************************************************************************
 * Opens user help written in English.
 * The program uses HTML files for help.  Users need a web browser such as
 * Netscape Navigator or Internet Explorer.
 * ****************************************************************************
 *)
const
  FileName = '..\manual\qr-main.html';
var
  Ans       : word;
begin
     Ans:=ShellExecute(Handle, 'open', FileName, nil, nil, SW_SHOWNORMAL);
     DisplayResult(Ans, FileName);
end;


procedure TformMain.menuHelpInJapClick(Sender: TObject);
(* ****************************************************************************
 * Opens user help written in English.
 * The program uses HTML files for help.  Users need a web browser such as
 * Netscape Navigator or Internet Explorer.
 * ****************************************************************************
 *)
const
  FileName = '..\manual\qr-main-j.html';
var
  Ans       : word;
begin
     Ans:=ShellExecute(Handle, 'open', FileName, nil, nil, SW_SHOWNORMAL);
     DisplayResult(Ans, FileName);
end;


procedure TformMain.radiogroupScaleClick(Sender: TObject);
(* ****************************************************************************
 * Sets scale mode.
 * ****************************************************************************
 *)
var
  Flag : Boolean;
begin
  if radiogroupScale.ItemIndex=0 then Flag:=False
  else Flag:=True;
  menuOptionAutoScale.Checked:=Flag;
  menuOptionAutoScaleClick(Sender);
end;


procedure TformMain.FormResize(Sender: TObject);
(* ****************************************************************************
 * Sets scale mode to "Auto", and redraw the image.
 * ****************************************************************************
 *)
begin
  menuOptionAutoScale.Checked:=False;
  menuOptionAutoScaleClick(Sender);
end;


procedure TformMain.menuFileExitClick(Sender: TObject);
(* ****************************************************************************
 * Just closes the form.
 * ****************************************************************************
 *)
begin
  Close;
end;


procedure TformMain.menuFileDeleteClick(Sender: TObject);
(* ****************************************************************************
 * Deletes current photo image from the database table.
 * ****************************************************************************
 *)
var
  Mess   : String;
  Result : word;
begin
  if queryAlbum.Active=False then begin
    MessageDlg('No database.',mtWarning,[mbOK],0);
    exit;
  end;
  Mess:='The program will delete current image.'+chr($0D)+'Are you sure?';
  Result:=MessageDlg(Mess, mtConfirmation,[mbOK,mbCancel],0);
  if Result=mrOK then begin
    try
      queryAlbum.Delete;
    except;
      MessageDlg('No record.',mtWarning,[mbOK],0);
    end;
  end;
end;


procedure TformMain.queryAlbumAfterScroll(DataSet: TDataSet);
(* ****************************************************************************
 * Displays photo image after scrolling table.
 * ****************************************************************************
 *)
var
  ImageStream : TStream;
  JpegImage   : TJPEGImage;
begin
  Screen.Cursor := crHourglass;
  try
    if TBlobField(queryAlbum.FieldByName('IMAGE')).IsNull then begin
      Screen.Cursor:=crArrow;
      imageViewArea.Visible:=False;
      exit;
    end;
    ImageStream:=TBlobStream.Create(TBlobField(queryAlbum.FieldByName('IMAGE')),bmRead);
    JpegImage:=TJPEGImage.Create;
    JpegImage.LoadFromStream(ImageStream);
    imageTmp.Picture.Graphic:=JpegImage;
    ImageStream.Free;
    JpegImage.Free;
    menuOptionAutoScale.Checked:=False;
    menuOptionAutoScaleClick(Dataset);
  finally;
  end;
  Screen.Cursor := crArrow;

  if IsShown('formKeywordAssist') and formMain.Active=True then begin
    formKeywordAssist.Show;
    formKeywordAssist.LoadKeywordToListBox;
  end;

end;


procedure TformMain.FormCreate(Sender: TObject);
(* ****************************************************************************
 * Sets initial values.
 * ****************************************************************************
 *)
begin
  Edited:=False;
  if ExistKey(BaseKeyName+'\'+formMain.Name) then begin
    RestoreFormStatus(formMain,Global.BaseKeyName);
    RestoreOptionStatus;
  end
  else begin
    Width:=640;
    Height:=480;
    Position:=poScreenCenter;
    WaitTime:=3;
    DisplayWaitTime(WaitTime);
  end;
end;


procedure TformMain.FormDestroy(Sender: TObject);
(* ****************************************************************************
 * Stores option statuses when the registories have been existed.
 * Please note users can remove the registories for this program when it is
 * running.
 * ****************************************************************************
 *)
begin
  if ExistKey(Global.BaseKeyName) then begin
    StoreFormStatus(formMain,BaseKeyName);
    StoreOptionStatus;
  end;
end;


procedure TformMain.menuOptionDeleteRegistoryClick(Sender: TObject);
(* ****************************************************************************
 * Removes registories for this program.
 * ****************************************************************************
 *)
var
  Mess : String;
begin
  if ExistKey(BaseKeyName) then begin
    Delete_Key(BaseKeyName);
    Mess:='It is just deleted.'+chr($0D)+'It will be re-create when program starts.';
    MessageDlg(Mess,mtInformation,[mbOK],0);
  end
  else begin
    Mess:='Target registory is not existed.';
    MessageDlg(Mess,mtInformation,[mbOK],0);
  end;
end;


procedure TformMain.menuDisplayFilterClick(Sender: TObject);
(* ****************************************************************************
 * Shows the "Easy Filter" form.
 * ****************************************************************************
 *)
begin
  if queryAlbum.Active=True then begin
    formEasyFilter.Showmodal;
  end
  else begin
    MessageDlg('No database.',mtWarning,[mbOK],0);
  end;
end;


procedure TformMain.DisplayRecordCount;
(* ****************************************************************************
 * Displays the number of the records.
 * ****************************************************************************
 *)
var
  NoOfRecord : Longint;
begin
  if queryAlbum.Active=True then begin
    NoOfRecord:=queryAlbum.RecordCount;
  end
  else begin
    NoOfRecord:=0;
  end;
  editCounter.Text:=IntToStr(NoOfRecord);
  if NoOfRecord=0 then imageViewArea.Visible:=False;
end;


procedure TformMain.queryAlbumAfterInsert(DataSet: TDataSet);
(* ****************************************************************************
 * Displays the number of the records after insertion of then photo image.
 * ****************************************************************************
 *)
begin
  DisplayRecordCount;
end;


procedure TformMain.queryAlbumAfterDelete(DataSet: TDataSet);
(* ****************************************************************************
 * Displays the number of the records after deleting of then photo image.
 * ****************************************************************************
 *)
begin
  if IsShown('formKeywordAssist') then begin
    formKeywordAssist.Show;
    formKeywordAssist.LoadKeywordToListBox;
  end;
  DisplayRecordCount;
end;


procedure TformMain.menuDisplayExpertClick(Sender: TObject);
(* ****************************************************************************
 * Displays the "Expert Filter" form.
 * ****************************************************************************
 *)
begin
  formExpertFilter.Showmodal;
end;


procedure TformMain.menuOptionLayoutClick(Sender: TObject);
(* ****************************************************************************
 * Exchange then layout of the command panel.
 * Users can locate it left or right hand side.
 * ****************************************************************************
 *)
begin
  case panelCommand.Align of
    alRight : panelCommand.Align:=alLeft;
    alLeft  : panelCommand.Align:=alRight;
  end;
end;


procedure TformMain.menuDisplayRefreshClick(Sender: TObject);
(* ****************************************************************************
 * Re draw photo image.
 * ****************************************************************************
 *)
var
  Stretch : Boolean;
begin
  if queryAlbum.FieldByName('IMAGE').IsNull=True then begin
    MessageDlg('No active record.',mtWarning,[mbOK],0);
  end
  else begin
    Stretch:=menuOptionAutoScale.Checked;
    imgtrans.ImageTransfer(imageTmp,imageViewArea,scrollboxViewArea,Stretch);
  end
end;


procedure TformMain.menuFileOpenClick(Sender: TObject);
(* ****************************************************************************
 * Opens database table which is already existed.
 * ****************************************************************************
 *)
var
  DriveDir : String;
begin
  if Edited=True then begin
    MessageDlg('Current record is modified.  Please update or cancel it first.',
    mtWarning,[mbOK],0);
    exit;
  end;
  if dialogOpen.Execute then begin
    DriveDir:=ExtractFileDir(dialogOpen.FileName);
    queryAlbum.Active:=False;
    queryAlbum.DatabaseName:=DriveDir;
    queryAlbum.Active:=True;
    DisplayRecordCount;
    tableKeyword.Active:=False;
    tableKeyword.DatabaseName:=DriveDir;
    tableKeyword.Active:=True;
  end;
end;


procedure TformMain.CreateTables(DatabaseDir:string);
(* ****************************************************************************
 * Creates new database tables, "photodb.db" and "keyword.db".
 * The tables are created in the directory indicated by the "DatabaseDir".
 * ****************************************************************************
 *)
const
  PhotoTableName = 'photodb.db';
  KeywordTableName = 'keyword.db';
begin
  if FileExists(DatabaseDir+'\'+PhotoTableName) then begin
    MessageDlg('Photo table is already existed.',mtWarning,[mbOK],0);
    Exit;
  end;
  if FileExists(DatabaseDir+'\'+KeywordTableName) then begin
    MessageDlg('Keyword table is already existed.',mtWarning,[mbOK],0);
    Exit;
  end;

  (* Photo image table *)
  tableNew.Active:=False;
  tableNew.DatabaseName:=DatabaseDir;
  tableNew.TableName:=PhotoTableName;
  tableNew.TableType:=ttDefault;
  tableNew.FieldDefs.Clear;
  tableNew.FieldDefs.Add('PREFIX',      ftString,  32, False);
  tableNew.FieldDefs.Add('NAME',        ftString,  32, True);
  tableNew.FieldDefs.Add('EXT',         ftString,   4, False);
  tableNew.FieldDefs.Add('SERIAL',      ftAutoInc,  0, True);
  tableNew.FieldDefs.Add('KEYWORD',     ftString, 255, True);
  tableNew.FieldDefs.Add('COUNT',       ftInteger,  0, True);
  tableNew.FieldDefs.Add('IMAGE_SIZE',  ftInteger,  0, True);
  tableNew.FieldDefs.Add('MEMO',        ftMemo,   240, False);
  tableNew.FieldDefs.Add('IMAGE',       ftGraphic,  0, True);
  tableNew.FieldDefs.Add('THUMBNAIL',   ftGraphic,  0, False);
  tableNew.IndexDefs.Clear;
  tableNew.IndexDefs.Add('','PREFIX;NAME;EXT;SERIAL',[ixPrimary,ixUnique]);
  try
    tableNew.CreateTable;
    tableNew.Active:=False;
    MessageDlg('Created "'+PhotoTableName+'".',mtInformation,[mbOK],0);
  except
    MessageDlg('Could not create "'+PhotoTableName+'".', mtWarning, [mbOK],0);
    tableNew.Active:=False;
    Exit;
  end;

  (* Keyword table *)
  tableNew.Active:=False;
  tableNew.DatabaseName:=DatabaseDir;
  tableNew.TableName:= KeywordTableName;
  tableNew.TableType:=ttDefault;
  tableNew.FieldDefs.Clear;
  tableNew.FieldDefs.Add('KEYWORD',     ftString,  32, True);
  tableNew.FieldDefs.Add('COUNT',       ftInteger,  0, True);
  tableNew.IndexDefs.Clear;
  tableNew.IndexDefs.Add('','KEYWORD',[ixPrimary,ixUnique]);
  try
    tableNew.CreateTable;
    tableNew.Active:=False;
    MessageDlg('Created "'+KeywordTableName+'".',mtInformation,[mbOK],0);
  except
    MessageDlg('Could not create "'+KeywordTableName+'".', mtWarning, [mbOK],0);
    tableNew.Active:=False;
  end;
end;


procedure TformMain.menuFileNewClick(Sender: TObject);
(* ****************************************************************************
 * Creates new database tables, and activates them.
 * ****************************************************************************
 *)
var
  DatabaseDir : String;
begin
  if SelectDirectory(DatabaseDir,
   [sdAllowCreate, sdPerformCreate, sdPrompt],0)=False then Exit;
  CreateTables(DatabaseDir);
  queryAlbum.Active:=False;
  queryAlbum.Databasename:=DatabaseDir;
  queryAlbum.Active:=True;
  DisplayRecordCount;
end;


procedure TformMain.menuDisplaySlideClick(Sender: TObject);
(* ****************************************************************************
 * Displays the photo image in the maximum size.
 * ****************************************************************************
 *)
var
  Stretch : Boolean;
begin
  if queryAlbum.FieldByName('IMAGE').IsNull then begin
    MessageDlg('Empty record.',mtWarning,[mbOK],0);
    exit;
  end;
  Stretch:=menuOptionAutoScale.Checked;
  imgtrans.ImageTransfer(imageTmp,formSlide.imageViewArea,formSlide.scrollboxViewArea,Stretch);
  formSlide.Show;
  IncCounter;
end;


procedure TformMain.queryAlbumAfterEdit(DataSet: TDataSet);
(* ****************************************************************************
 * Sets the "Edited" flag to True.
 * You must "post" when you close table or open new table,
 * if the "Edited" flag is True.
 * ****************************************************************************
 *)
begin
  Edited:=True;
end;


procedure TformMain.queryAlbumAfterPost(DataSet: TDataSet);
(* ****************************************************************************
 * Sets the "Edited" flag to False.
 * ****************************************************************************
 *)
var
  CurrentSerial : Longint;
begin
  if TBlobField(queryAlbum.FieldByName('IMAGE')).IsNull then begin
    imageViewArea.Visible:=False;
  end
  else begin
    CurrentSerial:=queryAlbum.FieldByName('SERIAL').AsInteger;
    if CurrentSerial<>LastSerial then begin
      queryAlbumAfterScroll(DataSet);
      if IsShown('formKeywordAssist') then formKeywordAssist.LoadKeywordToListBox;
    end;
  end;
  Edited:=False;
end;


procedure TformMain.menuDisplaySlideshowClick(Sender: TObject);
(* ****************************************************************************
 * Displays the photo images continuously.
 * ****************************************************************************
 *)
begin
  if queryAlbum.Active=False then begin
    MessageDlg('Database is not active.',mtWarning,[mbOK],0);
    Exit;
  end;
  if queryAlbum.FieldByName('IMAGE').IsNull then begin
    MessageDlg('Empty record.',mtInformation,[mbOK],0);
    exit;
  end;
  Clicked:=False;
  while not(queryAlbum.EOF) and not(Clicked) do begin
    imgtrans.ImageTransfer(imageTmp,formSlide.imageViewArea,formSlide.scrollboxViewArea,True);
    formSlide.Show;
    formSlide.Update;
    if WaitTime>0 then begin
      OnTime:=False;
      timerWaitTime.Enabled:=True;
      while not(OnTime) and not(Clicked) do begin
        Application.ProcessMessages;
      end;
    end;
    Application.ProcessMessages;
    if not(Clicked) then begin
      IncCounter;
      queryAlbum.Next;
    end;
  end;
  if not(Clicked) then formSlide.Close;
end;


procedure TformMain.menuOptionWaitTimeClick(Sender: TObject);
(* ****************************************************************************
 * Entry of the wait time for the slideshow.
 * ****************************************************************************
 *)
var
  Str : String;
begin
  Str:=InputBox('Slideshow wait time entry','Enter wait time in seconds between 0 to 10.',IntToStr(WaitTime));
  if Str<>'' then begin
    try
      WaitTime:=StrToInt(Str);
    except
      WaitTime:=3;
    end;
    if WaitTime<0 then WaitTime:=0;
    if WaitTime>10 then WaitTime:=10;
  end;
  DisplayWaitTime(WaitTime);
end;


procedure TformMain.timerWaitTimeTimer(Sender: TObject);
(* ****************************************************************************
 * Enables the interval timer.
 * ****************************************************************************
 *)
begin
  timerWaitTime.Enabled:=False;
  OnTime:=True;
end;


procedure TformMain.menuOptionAutoScaleClick(Sender: TObject);
(* ****************************************************************************
 * Sets scale mode and redraws photo image.
 * ****************************************************************************
 *)
begin
  if menuOptionAutoScale.Checked=True then begin
    menuOptionAutoScale.Checked:=False;
    radiogroupScale.ItemIndex:=1;
    imgtrans.ImageTransfer(imageTmp,imageViewArea,scrollboxViewArea,False);
  end
  else begin
    menuOptionAutoScale.Checked:=True;
    radiogroupScale.ItemIndex:=0;
    imgtrans.ImageTransfer(imageTmp,imageViewArea,scrollboxViewArea,True);
  end;
end;


procedure TformMain.menuOptionTableHeightHigherClick(Sender: TObject);
(* ****************************************************************************
 * Higher dbgrid height.
 * ****************************************************************************
 *)
begin
  dbgridAlbum.Height:=dbgridAlbum.Height+10;
  menuOptionAutoScale.Checked:=False;
  menuOptionAutoScaleClick(Sender);
end;


procedure TformMain.menuOptionTableHeightLowerClick(Sender: TObject);
(* ****************************************************************************
 * Lower dbgrid height.
 * ****************************************************************************
 *)
begin
  dbgridAlbum.Height:=dbgridAlbum.Height-10;
  menuOptionAutoScale.Checked:=False;
  menuOptionAutoScaleClick(Sender);
end;


procedure TformMain.menuFileExportCurrentClick(Sender: TObject);
(* ****************************************************************************
 * Exports current photo image as a file.
 * ****************************************************************************
 *)
var
  FullPath   : String;
  NameAndExt : String;
begin
  if queryAlbum.RecordCount=0 then begin
    MessageDlg('No record.',mtWarning,[mbOK],0);
    Exit;
  end;
  NameAndExt:=queryAlbum.FieldByName('NAME').AsString
    + queryAlbum.FieldByName('EXT').AsString;
  dialogSave.FileName:=NameAndExt;
  if dialogSave.Execute=False then Exit;
  FullPath:=dialogSave.FileName;
  if FileExists(FullPath) then begin
    if MessageDlg('The file "'+FullPath+'" is already existed.'+chr($0D)+
      'Do you overwrite it?',mtConfirmation,[mbYes,mbNo],0)=mrNo then Exit;
  end;
  try
    TBlobField(formMain.queryAlbum.FieldByName('IMAGE')).SaveToFile(FullPath);
    MessageDlg('Exported to "'+FullPath+'".',mtInformation,[mbOK],0);
  except
    MessageDlg('Could not save to "'+FullPath+'".',mtWarning,[mbOK],0);
  end;
end;


procedure TformMain.menuFileInportFileClick(Sender: TObject);
(* ****************************************************************************
 * Shows file select form.
 * ****************************************************************************
 *)
begin
  if queryAlbum.Active=True then begin
    formSelector.Showmodal;
  end
  else begin
    MessageDlg('No database.',mtWarning,[mbOK],0);
  end;
end;

procedure TformMain.menuHelpVersionClick(Sender: TObject);
(* ****************************************************************************
 * Shows Version Informations.
 * ****************************************************************************
 *)
const
  CR = chr($0D);
var
  Mess : String;
begin
  Mess:=VerInfo.GetVersionInfo('ProductName')+CR
       +VerInfo.GetVersionInfo('FileDescription')+CR
       +'Version '+VerInfo.GetVersionInfo('FileVersion')+CR
       +'Copyright '+VerInfo.GetVersionInfo('LegalCopyright')+CR
       +'Homepage '+VerInfo.GetVersionInfo('Homepage');
  MessageDlg(Mess,mtInformation,[mbOK],0);
end;

procedure TformMain.menuDisplayKeywordListClick(Sender: TObject);
begin
  formKeywordList.ShowModal;
end;

procedure TformMain.menuDisplayKeywordAssistClick(Sender: TObject);
begin
  if not(IsShown('formKeywordAssist')) then Application.CreateForm(TformKeywordAssist, formKeywordAssist);
  formKeywordAssist.Show;
end;

procedure TformMain.menuDisplayKeywordEditClick(Sender: TObject);
begin
  formKeywordEdit.ShowModal;
end;

procedure TformMain.bitbtnKeywordAssistClick(Sender: TObject);
begin
  formKeywordAssist.Show;
end;

procedure TformMain.queryAlbumBeforePost(DataSet: TDataSet);
begin
  CheckKeywordEntry;
  LastSerial:=queryAlbum.FieldByName('SERIAL').AsInteger;
end;

end.

